/* Toast.c generated by valac 0.56.17, the Vala compiler
 * generated from Toast.vala, do not modify */

/*-
 * Copyright 2016-2022 elementary, Inc. (https://elementary.io)
 * Copyright 2016-2017 Artem Anufrij <artem.anufrij@live.de>
 * Copyright 2016-2017 Daniel Foré <daniel@elementary.io>
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite-7.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GRANITE_TOAST_0_PROPERTY,
	GRANITE_TOAST_TITLE_PROPERTY,
	GRANITE_TOAST_NUM_PROPERTIES
};
static GParamSpec* granite_toast_properties[GRANITE_TOAST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GRANITE_TOAST_CLOSED_SIGNAL,
	GRANITE_TOAST_DISMISSED_SIGNAL,
	GRANITE_TOAST_DEFAULT_ACTION_SIGNAL,
	GRANITE_TOAST_NUM_SIGNALS
};
static guint granite_toast_signals[GRANITE_TOAST_NUM_SIGNALS] = {0};

struct _GraniteToastPrivate {
	GtkRevealer* revealer;
	GtkLabel* notification_label;
	GtkButton* default_action_button;
	gchar* _title;
	guint timeout_id;
};

static gint GraniteToast_private_offset;
static gpointer granite_toast_parent_class = NULL;

static void granite_toast_start_timeout (GraniteToast* self);
static gboolean __lambda35_ (GraniteToast* self);
static gboolean ___lambda35__gsource_func (gpointer self);
static void granite_toast_stop_timeout (GraniteToast* self);
static GObject * granite_toast_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _granite_toast___lambda36_ (GraniteToast* self);
static void __granite_toast___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static void _granite_toast___lambda37_ (GraniteToast* self);
static void __granite_toast___lambda37__gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static void _granite_toast___lambda38_ (GraniteToast* self);
static void __granite_toast___lambda38__gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void _granite_toast___lambda39_ (GraniteToast* self);
static void __granite_toast___lambda39__gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                                    gpointer self);
static void granite_toast_finalize (GObject * obj);
static GType granite_toast_get_type_once (void);
static void _vala_granite_toast_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_granite_toast_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
granite_toast_get_instance_private (GraniteToast* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteToast_private_offset);
}

/**
     * Reason why a Toast was dismissed
     * @since 7.5.0
     */
static GType
granite_toast_dismiss_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{GRANITE_TOAST_DISMISS_REASON_EXPIRED, "GRANITE_TOAST_DISMISS_REASON_EXPIRED", "expired"}, {GRANITE_TOAST_DISMISS_REASON_CLOSED, "GRANITE_TOAST_DISMISS_REASON_CLOSED", "closed"}, {GRANITE_TOAST_DISMISS_REASON_WITHDRAWN, "GRANITE_TOAST_DISMISS_REASON_WITHDRAWN", "withdrawn"}, {0, NULL, NULL}};
	GType granite_toast_dismiss_reason_type_id;
	granite_toast_dismiss_reason_type_id = g_enum_register_static ("GraniteToastDismissReason", values);
	return granite_toast_dismiss_reason_type_id;
}

GType
granite_toast_dismiss_reason_get_type (void)
{
	static volatile gsize granite_toast_dismiss_reason_type_id__once = 0;
	if (g_once_init_enter (&granite_toast_dismiss_reason_type_id__once)) {
		GType granite_toast_dismiss_reason_type_id;
		granite_toast_dismiss_reason_type_id = granite_toast_dismiss_reason_get_type_once ();
		g_once_init_leave (&granite_toast_dismiss_reason_type_id__once, granite_toast_dismiss_reason_type_id);
	}
	return granite_toast_dismiss_reason_type_id__once;
}

const gchar*
granite_toast_get_title (GraniteToast* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../lib/Widgets/Toast.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->_title;
#line 57 "../lib/Widgets/Toast.vala"
	result = _tmp0_;
#line 57 "../lib/Widgets/Toast.vala"
	return result;
#line 134 "Toast.c"
}

void
granite_toast_set_title (GraniteToast* self,
                         const gchar* value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp2_;
#line 59 "../lib/Widgets/Toast.vala"
	g_return_if_fail (self != NULL);
#line 60 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->notification_label;
#line 60 "../lib/Widgets/Toast.vala"
	if (_tmp0_ != NULL) {
#line 149 "Toast.c"
		GtkLabel* _tmp1_;
#line 61 "../lib/Widgets/Toast.vala"
		_tmp1_ = self->priv->notification_label;
#line 61 "../lib/Widgets/Toast.vala"
		gtk_label_set_label (_tmp1_, value);
#line 155 "Toast.c"
	}
#line 63 "../lib/Widgets/Toast.vala"
	_tmp2_ = g_strdup (value);
#line 63 "../lib/Widgets/Toast.vala"
	_g_free0 (self->priv->_title);
#line 63 "../lib/Widgets/Toast.vala"
	self->priv->_title = _tmp2_;
#line 59 "../lib/Widgets/Toast.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_toast_properties[GRANITE_TOAST_TITLE_PROPERTY]);
#line 165 "Toast.c"
}

/**
     * Creates a new Toast with #title as its title
     */
GraniteToast*
granite_toast_construct (GType object_type,
                         const gchar* title)
{
	GraniteToast * self = NULL;
#line 70 "../lib/Widgets/Toast.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 71 "../lib/Widgets/Toast.vala"
	self = (GraniteToast*) g_object_new (object_type, "title", title, NULL);
#line 70 "../lib/Widgets/Toast.vala"
	return self;
#line 182 "Toast.c"
}

GraniteToast*
granite_toast_new (const gchar* title)
{
#line 70 "../lib/Widgets/Toast.vala"
	return granite_toast_construct (GRANITE_TYPE_TOAST, title);
#line 190 "Toast.c"
}

static gboolean
__lambda35_ (GraniteToast* self)
{
	GtkRevealer* _tmp0_;
	gboolean result;
#line 152 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->revealer;
#line 152 "../lib/Widgets/Toast.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 153 "../lib/Widgets/Toast.vala"
	g_signal_emit (self, granite_toast_signals[GRANITE_TOAST_DISMISSED_SIGNAL], 0, GRANITE_TOAST_DISMISS_REASON_EXPIRED);
#line 154 "../lib/Widgets/Toast.vala"
	self->priv->timeout_id = (guint) 0;
#line 155 "../lib/Widgets/Toast.vala"
	result = G_SOURCE_REMOVE;
#line 155 "../lib/Widgets/Toast.vala"
	return result;
#line 210 "Toast.c"
}

static gboolean
___lambda35__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda35_ ((GraniteToast*) self);
#line 151 "../lib/Widgets/Toast.vala"
	return result;
#line 220 "Toast.c"
}

static void
granite_toast_start_timeout (GraniteToast* self)
{
	guint duration = 0U;
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 142 "../lib/Widgets/Toast.vala"
	g_return_if_fail (self != NULL);
#line 145 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->default_action_button;
#line 145 "../lib/Widgets/Toast.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 145 "../lib/Widgets/Toast.vala"
	_tmp2_ = _tmp1_;
#line 145 "../lib/Widgets/Toast.vala"
	if (_tmp2_) {
#line 146 "../lib/Widgets/Toast.vala"
		duration = (guint) 3500;
#line 242 "Toast.c"
	} else {
#line 148 "../lib/Widgets/Toast.vala"
		duration = (guint) 2000;
#line 246 "Toast.c"
	}
#line 151 "../lib/Widgets/Toast.vala"
	self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, duration, ___lambda35__gsource_func, g_object_ref (self), g_object_unref);
#line 250 "Toast.c"
}

static void
granite_toast_stop_timeout (GraniteToast* self)
{
#line 159 "../lib/Widgets/Toast.vala"
	g_return_if_fail (self != NULL);
#line 160 "../lib/Widgets/Toast.vala"
	if (self->priv->timeout_id != ((guint) 0)) {
#line 161 "../lib/Widgets/Toast.vala"
		g_source_remove (self->priv->timeout_id);
#line 162 "../lib/Widgets/Toast.vala"
		self->priv->timeout_id = (guint) 0;
#line 264 "Toast.c"
	}
}

/**
     * Sets the default action button label of #this to #label and hides the
     * button if #label is #null.
     */
void
granite_toast_set_default_action (GraniteToast* self,
                                  const gchar* label)
{
	gboolean _tmp0_ = FALSE;
	GtkButton* _tmp3_;
#line 170 "../lib/Widgets/Toast.vala"
	g_return_if_fail (self != NULL);
#line 171 "../lib/Widgets/Toast.vala"
	if (g_strcmp0 (label, "") == 0) {
#line 171 "../lib/Widgets/Toast.vala"
		_tmp0_ = TRUE;
#line 284 "Toast.c"
	} else {
#line 171 "../lib/Widgets/Toast.vala"
		_tmp0_ = label == NULL;
#line 288 "Toast.c"
	}
#line 171 "../lib/Widgets/Toast.vala"
	if (_tmp0_) {
#line 292 "Toast.c"
		GtkButton* _tmp1_;
#line 172 "../lib/Widgets/Toast.vala"
		_tmp1_ = self->priv->default_action_button;
#line 172 "../lib/Widgets/Toast.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 298 "Toast.c"
	} else {
		GtkButton* _tmp2_;
#line 174 "../lib/Widgets/Toast.vala"
		_tmp2_ = self->priv->default_action_button;
#line 174 "../lib/Widgets/Toast.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 305 "Toast.c"
	}
#line 176 "../lib/Widgets/Toast.vala"
	_tmp3_ = self->priv->default_action_button;
#line 176 "../lib/Widgets/Toast.vala"
	gtk_button_set_label (_tmp3_, label);
#line 311 "Toast.c"
}

/**
     * Sends the Toast on behalf of #this
     */
void
granite_toast_send_notification (GraniteToast* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 182 "../lib/Widgets/Toast.vala"
	g_return_if_fail (self != NULL);
#line 183 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->revealer;
#line 183 "../lib/Widgets/Toast.vala"
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
#line 183 "../lib/Widgets/Toast.vala"
	_tmp2_ = _tmp1_;
#line 183 "../lib/Widgets/Toast.vala"
	if (!_tmp2_) {
#line 333 "Toast.c"
		GtkRevealer* _tmp3_;
#line 184 "../lib/Widgets/Toast.vala"
		_tmp3_ = self->priv->revealer;
#line 184 "../lib/Widgets/Toast.vala"
		gtk_revealer_set_reveal_child (_tmp3_, TRUE);
#line 339 "Toast.c"
	}
#line 189 "../lib/Widgets/Toast.vala"
	granite_toast_stop_timeout (self);
#line 190 "../lib/Widgets/Toast.vala"
	granite_toast_start_timeout (self);
#line 345 "Toast.c"
}

/**
     * Withdraws the currently displayed Toast
     * @since 7.4.0
     */
void
granite_toast_withdraw (GraniteToast* self)
{
	GtkRevealer* _tmp0_;
#line 198 "../lib/Widgets/Toast.vala"
	g_return_if_fail (self != NULL);
#line 199 "../lib/Widgets/Toast.vala"
	granite_toast_stop_timeout (self);
#line 200 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->revealer;
#line 200 "../lib/Widgets/Toast.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 201 "../lib/Widgets/Toast.vala"
	g_signal_emit (self, granite_toast_signals[GRANITE_TOAST_DISMISSED_SIGNAL], 0, GRANITE_TOAST_DISMISS_REASON_WITHDRAWN);
#line 366 "Toast.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 109 "../lib/Widgets/Toast.vala"
	return self ? g_object_ref (self) : NULL;
#line 374 "Toast.c"
}

static void
_granite_toast___lambda36_ (GraniteToast* self)
{
	GtkRevealer* _tmp0_;
#line 117 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->revealer;
#line 117 "../lib/Widgets/Toast.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 118 "../lib/Widgets/Toast.vala"
	granite_toast_stop_timeout (self);
#line 119 "../lib/Widgets/Toast.vala"
	g_signal_emit (self, granite_toast_signals[GRANITE_TOAST_CLOSED_SIGNAL], 0);
#line 120 "../lib/Widgets/Toast.vala"
	g_signal_emit (self, granite_toast_signals[GRANITE_TOAST_DISMISSED_SIGNAL], 0, GRANITE_TOAST_DISMISS_REASON_CLOSED);
#line 391 "Toast.c"
}

static void
__granite_toast___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 116 "../lib/Widgets/Toast.vala"
	_granite_toast___lambda36_ ((GraniteToast*) self);
#line 400 "Toast.c"
}

static void
_granite_toast___lambda37_ (GraniteToast* self)
{
	GtkRevealer* _tmp0_;
#line 124 "../lib/Widgets/Toast.vala"
	_tmp0_ = self->priv->revealer;
#line 124 "../lib/Widgets/Toast.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 125 "../lib/Widgets/Toast.vala"
	granite_toast_stop_timeout (self);
#line 126 "../lib/Widgets/Toast.vala"
	g_signal_emit (self, granite_toast_signals[GRANITE_TOAST_DEFAULT_ACTION_SIGNAL], 0);
#line 415 "Toast.c"
}

static void
__granite_toast___lambda37__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 123 "../lib/Widgets/Toast.vala"
	_granite_toast___lambda37_ ((GraniteToast*) self);
#line 424 "Toast.c"
}

static void
_granite_toast___lambda38_ (GraniteToast* self)
{
#line 130 "../lib/Widgets/Toast.vala"
	granite_toast_stop_timeout (self);
#line 432 "Toast.c"
}

static void
__granite_toast___lambda38__gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
#line 129 "../lib/Widgets/Toast.vala"
	_granite_toast___lambda38_ ((GraniteToast*) self);
#line 443 "Toast.c"
}

static void
_granite_toast___lambda39_ (GraniteToast* self)
{
#line 134 "../lib/Widgets/Toast.vala"
	granite_toast_start_timeout (self);
#line 451 "Toast.c"
}

static void
__granite_toast___lambda39__gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                               gpointer self)
{
#line 133 "../lib/Widgets/Toast.vala"
	_granite_toast___lambda39_ ((GraniteToast*) self);
#line 460 "Toast.c"
}

static GObject *
granite_toast_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteToast * self;
	GtkButton* _tmp0_ = NULL;
	GtkButton* close_button = NULL;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkButton* _tmp9_;
	GtkBox* _tmp10_;
	GtkLabel* _tmp11_;
	GtkBox* _tmp12_;
	GtkButton* _tmp13_;
	GtkEventControllerMotion* motion_controller = NULL;
	GtkEventControllerMotion* _tmp14_;
	GtkBox* _tmp15_;
	GtkWidget* _tmp16_;
	GtkRevealer* _tmp17_ = NULL;
	GtkRevealer* _tmp18_;
	GtkEventControllerMotion* _tmp19_;
	GtkEventController* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkEventControllerMotion* _tmp23_;
	GtkEventControllerMotion* _tmp24_;
#line 82 "../lib/Widgets/Toast.vala"
	parent_class = G_OBJECT_CLASS (granite_toast_parent_class);
#line 82 "../lib/Widgets/Toast.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 82 "../lib/Widgets/Toast.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_TYPE_TOAST, GraniteToast);
#line 83 "../lib/Widgets/Toast.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 84 "../lib/Widgets/Toast.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
#line 86 "../lib/Widgets/Toast.vala"
	_tmp0_ = (GtkButton*) gtk_button_new ();
#line 86 "../lib/Widgets/Toast.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 86 "../lib/Widgets/Toast.vala"
	g_object_ref_sink (_tmp0_);
#line 86 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (self->priv->default_action_button);
#line 86 "../lib/Widgets/Toast.vala"
	self->priv->default_action_button = _tmp0_;
#line 90 "../lib/Widgets/Toast.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic");
#line 90 "../lib/Widgets/Toast.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 90 "../lib/Widgets/Toast.vala"
	g_object_ref_sink (_tmp1_);
#line 90 "../lib/Widgets/Toast.vala"
	close_button = _tmp1_;
#line 93 "../lib/Widgets/Toast.vala"
	_tmp2_ = close_button;
#line 93 "../lib/Widgets/Toast.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp2_, GRANITE_STYLE_CLASS_CIRCULAR);
#line 95 "../lib/Widgets/Toast.vala"
	_tmp3_ = granite_toast_get_title (self);
#line 95 "../lib/Widgets/Toast.vala"
	_tmp4_ = _tmp3_;
#line 95 "../lib/Widgets/Toast.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 95 "../lib/Widgets/Toast.vala"
	gtk_label_set_wrap (_tmp5_, TRUE);
#line 95 "../lib/Widgets/Toast.vala"
	gtk_label_set_wrap_mode (_tmp5_, PANGO_WRAP_WORD);
#line 95 "../lib/Widgets/Toast.vala"
	gtk_label_set_natural_wrap_mode (_tmp5_, GTK_NATURAL_WRAP_NONE);
#line 95 "../lib/Widgets/Toast.vala"
	g_object_ref_sink (_tmp5_);
#line 95 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (self->priv->notification_label);
#line 95 "../lib/Widgets/Toast.vala"
	self->priv->notification_label = _tmp5_;
#line 101 "../lib/Widgets/Toast.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 101 "../lib/Widgets/Toast.vala"
	g_object_ref_sink (_tmp6_);
#line 101 "../lib/Widgets/Toast.vala"
	box = _tmp6_;
#line 102 "../lib/Widgets/Toast.vala"
	_tmp7_ = box;
#line 102 "../lib/Widgets/Toast.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp7_, GRANITE_STYLE_CLASS_OSD);
#line 103 "../lib/Widgets/Toast.vala"
	_tmp8_ = box;
#line 103 "../lib/Widgets/Toast.vala"
	_tmp9_ = close_button;
#line 103 "../lib/Widgets/Toast.vala"
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
#line 104 "../lib/Widgets/Toast.vala"
	_tmp10_ = box;
#line 104 "../lib/Widgets/Toast.vala"
	_tmp11_ = self->priv->notification_label;
#line 104 "../lib/Widgets/Toast.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 105 "../lib/Widgets/Toast.vala"
	_tmp12_ = box;
#line 105 "../lib/Widgets/Toast.vala"
	_tmp13_ = self->priv->default_action_button;
#line 105 "../lib/Widgets/Toast.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 107 "../lib/Widgets/Toast.vala"
	_tmp14_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
#line 107 "../lib/Widgets/Toast.vala"
	motion_controller = _tmp14_;
#line 109 "../lib/Widgets/Toast.vala"
	_tmp15_ = box;
#line 109 "../lib/Widgets/Toast.vala"
	_tmp16_ = _g_object_ref0 ((GtkWidget*) _tmp15_);
#line 109 "../lib/Widgets/Toast.vala"
	_tmp17_ = (GtkRevealer*) gtk_revealer_new ();
#line 109 "../lib/Widgets/Toast.vala"
	gtk_revealer_set_child (_tmp17_, _tmp16_);
#line 109 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (_tmp16_);
#line 109 "../lib/Widgets/Toast.vala"
	g_object_ref_sink (_tmp17_);
#line 109 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (self->priv->revealer);
#line 109 "../lib/Widgets/Toast.vala"
	self->priv->revealer = _tmp17_;
#line 112 "../lib/Widgets/Toast.vala"
	_tmp18_ = self->priv->revealer;
#line 112 "../lib/Widgets/Toast.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp18_, (GtkWidget*) self);
#line 114 "../lib/Widgets/Toast.vala"
	_tmp19_ = motion_controller;
#line 114 "../lib/Widgets/Toast.vala"
	_tmp20_ = _g_object_ref0 ((GtkEventController*) _tmp19_);
#line 114 "../lib/Widgets/Toast.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp20_);
#line 116 "../lib/Widgets/Toast.vala"
	_tmp21_ = close_button;
#line 116 "../lib/Widgets/Toast.vala"
	g_signal_connect_object (_tmp21_, "clicked", (GCallback) __granite_toast___lambda36__gtk_button_clicked, self, 0);
#line 123 "../lib/Widgets/Toast.vala"
	_tmp22_ = self->priv->default_action_button;
#line 123 "../lib/Widgets/Toast.vala"
	g_signal_connect_object (_tmp22_, "clicked", (GCallback) __granite_toast___lambda37__gtk_button_clicked, self, 0);
#line 129 "../lib/Widgets/Toast.vala"
	_tmp23_ = motion_controller;
#line 129 "../lib/Widgets/Toast.vala"
	g_signal_connect_object (_tmp23_, "enter", (GCallback) __granite_toast___lambda38__gtk_event_controller_motion_enter, self, 0);
#line 133 "../lib/Widgets/Toast.vala"
	_tmp24_ = motion_controller;
#line 133 "../lib/Widgets/Toast.vala"
	g_signal_connect_object (_tmp24_, "leave", (GCallback) __granite_toast___lambda39__gtk_event_controller_motion_leave, self, 0);
#line 82 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (motion_controller);
#line 82 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (box);
#line 82 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (close_button);
#line 82 "../lib/Widgets/Toast.vala"
	return obj;
#line 631 "Toast.c"
}

static void
granite_toast_base_init (GraniteToastClass * klass)
{
#line 79 "../lib/Widgets/Toast.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "toast");
#line 639 "Toast.c"
}

static void
granite_toast_class_init (GraniteToastClass * klass,
                          gpointer klass_data)
{
#line 18 "../lib/Widgets/Toast.vala"
	granite_toast_parent_class = g_type_class_peek_parent (klass);
#line 18 "../lib/Widgets/Toast.vala"
	g_type_class_adjust_private_offset (klass, &GraniteToast_private_offset);
#line 18 "../lib/Widgets/Toast.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_toast_get_property;
#line 18 "../lib/Widgets/Toast.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_toast_set_property;
#line 18 "../lib/Widgets/Toast.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_toast_constructor;
#line 18 "../lib/Widgets/Toast.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_toast_finalize;
#line 658 "Toast.c"
	/**
	     * The notification text label to be displayed inside of #this
	     */
#line 18 "../lib/Widgets/Toast.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_TOAST_TITLE_PROPERTY, granite_toast_properties[GRANITE_TOAST_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 664 "Toast.c"
	/**
	     * Emitted when the Toast is closed by activating the close button
	     */
#line 18 "../lib/Widgets/Toast.vala"
	granite_toast_signals[GRANITE_TOAST_CLOSED_SIGNAL] = g_signal_new ("closed", GRANITE_TYPE_TOAST, G_SIGNAL_RUN_LAST | G_SIGNAL_DEPRECATED, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 670 "Toast.c"
	/**
	     * Emitted when the Toast has been dismissed
	     */
#line 18 "../lib/Widgets/Toast.vala"
	granite_toast_signals[GRANITE_TOAST_DISMISSED_SIGNAL] = g_signal_new ("dismissed", GRANITE_TYPE_TOAST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, GRANITE_TOAST_TYPE_DISMISS_REASON);
#line 676 "Toast.c"
	/**
	     * Emitted when the default action button is activated
	     */
#line 18 "../lib/Widgets/Toast.vala"
	granite_toast_signals[GRANITE_TOAST_DEFAULT_ACTION_SIGNAL] = g_signal_new ("default-action", GRANITE_TYPE_TOAST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 75 "../lib/Widgets/Toast.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_bin_layout_get_type ());
#line 684 "Toast.c"
}

static void
granite_toast_instance_init (GraniteToast * self,
                             gpointer klass)
{
#line 18 "../lib/Widgets/Toast.vala"
	self->priv = granite_toast_get_instance_private (self);
#line 693 "Toast.c"
}

static void
granite_toast_finalize (GObject * obj)
{
	GraniteToast * self;
	GtkWidget* _tmp0_;
#line 18 "../lib/Widgets/Toast.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_TYPE_TOAST, GraniteToast);
#line 139 "../lib/Widgets/Toast.vala"
	_tmp0_ = gtk_widget_get_first_child ((GtkWidget*) self);
#line 139 "../lib/Widgets/Toast.vala"
	gtk_widget_unparent (_tmp0_);
#line 46 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (self->priv->revealer);
#line 47 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (self->priv->notification_label);
#line 48 "../lib/Widgets/Toast.vala"
	_g_object_unref0 (self->priv->default_action_button);
#line 49 "../lib/Widgets/Toast.vala"
	_g_free0 (self->priv->_title);
#line 18 "../lib/Widgets/Toast.vala"
	G_OBJECT_CLASS (granite_toast_parent_class)->finalize (obj);
#line 717 "Toast.c"
}

/**
 * Toasts are small in-app notifications that provide feedback about an operation
 * in a small popup. They only fill the space required to show the message and do
 * not block the UI.
 *
 * Granite.Widgets.Toast will get the style class .app-notification
 *
 * {{../doc/images/Toast.png}}
 */
static GType
granite_toast_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GraniteToastClass), (GBaseInitFunc) granite_toast_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_toast_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteToast), 0, (GInstanceInitFunc) granite_toast_instance_init, NULL };
	GType granite_toast_type_id;
	granite_toast_type_id = g_type_register_static (gtk_widget_get_type (), "GraniteToast", &g_define_type_info, 0);
	GraniteToast_private_offset = g_type_add_instance_private (granite_toast_type_id, sizeof (GraniteToastPrivate));
	return granite_toast_type_id;
}

GType
granite_toast_get_type (void)
{
	static volatile gsize granite_toast_type_id__once = 0;
	if (g_once_init_enter (&granite_toast_type_id__once)) {
		GType granite_toast_type_id;
		granite_toast_type_id = granite_toast_get_type_once ();
		g_once_init_leave (&granite_toast_type_id__once, granite_toast_type_id);
	}
	return granite_toast_type_id__once;
}

static void
_vala_granite_toast_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	GraniteToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_TYPE_TOAST, GraniteToast);
#line 18 "../lib/Widgets/Toast.vala"
	switch (property_id) {
#line 18 "../lib/Widgets/Toast.vala"
		case GRANITE_TOAST_TITLE_PROPERTY:
#line 18 "../lib/Widgets/Toast.vala"
		g_value_set_string (value, granite_toast_get_title (self));
#line 18 "../lib/Widgets/Toast.vala"
		break;
#line 767 "Toast.c"
		default:
#line 18 "../lib/Widgets/Toast.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../lib/Widgets/Toast.vala"
		break;
#line 773 "Toast.c"
	}
}

static void
_vala_granite_toast_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	GraniteToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_TYPE_TOAST, GraniteToast);
#line 18 "../lib/Widgets/Toast.vala"
	switch (property_id) {
#line 18 "../lib/Widgets/Toast.vala"
		case GRANITE_TOAST_TITLE_PROPERTY:
#line 18 "../lib/Widgets/Toast.vala"
		granite_toast_set_title (self, g_value_get_string (value));
#line 18 "../lib/Widgets/Toast.vala"
		break;
#line 793 "Toast.c"
		default:
#line 18 "../lib/Widgets/Toast.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../lib/Widgets/Toast.vala"
		break;
#line 799 "Toast.c"
	}
}

